import React, {Component} from 'react';
import {SpreadSheets, Worksheet} from '@grapecity/spread-sheets-react';
import '@grapecity/spread-sheets-charts';
import GC from "@grapecity/spread-sheets";
//import FileSaver from "file-saver";
//import ExcelIO from "@grapecity/spread-excelio";

import './Workbook.css'


class Workbook extends Component {
    constructor(props) {
        super(props);
        this.state = {
        };
    }
    // 工作簿初始化
    workbookInitialized(spread) {
        this.spread = spread;
        let sheet = spread.getActiveSheet();
        spread.setSheetCount(3);
        sheet.setColumnCount(5);
        sheet.setRowCount(10);
        sheet.options.sheetTabColor = 'green';
    }
    // 新增按钮
    newTab(e) {
        console.log(`checked = ${e.target.checked}`);
        this.spread.options.newTabVisible = e.target.checked;
    };
    // 标签是否可编辑
    tabEditable(e) {
        this.spread.options.tabEditable = e.target.checked;
    }
    // 是否允许拖动改变表单顺序
    allowSheetReorder(e) {
        this.spread.options.allowSheetReorder = e.target.checked;
    }
    // 显示水平滚动条
    horizonScroll(e) {
        this.spread.options.showHorizontalScrollbar = e.target.checked;
    }
    // 水平滚动条显示提示
    horizonScrollTip(e) {
        this.spread.options.showScrollTip = GC.Spread.Sheets.ShowScrollTip.horizontal;
    }
    // 竖直滚动条显示提示
    verticalScrollTip(e) {
        this.spread.options.showScrollTip = GC.Spread.Sheets.ShowScrollTip.vertical;
    }
    // 暂停绘制
    suspendPaint(e) {
        this.spread.suspendPaint();
    }
    // 重新激活绘制
    resumePaint(e) {
        this.spread.resumePaint();
    }
    // 背景色
    backColor(e) {
        this.spread.options.backColor = '#a079e8';
    }
    // 灰色区域背景色
    grayAreaBackColor(e){
        this.spread.options.grayAreaBackColor = '#351969';
    }

    render() {
        return (
            <div className={'Layout-container'}>
                <div className="Layout-aside">
                    <h3>表单名称标签</h3>
                    <div className='group'>
                        <div>
                            <input type="checkBox" defaultChecked='true' onChange={(e) => {this.newTab(e)}}/><label>显示新增按钮</label>
                        </div>
                        <div>
                            <input type="checkBox" defaultChecked='true' onChange={(e) => {this.tabEditable(e)}}/><label>标签可编辑</label>
                        </div>
                        <div>
                            <input type="checkBox" defaultChecked='true' onChange={(e) => {this.allowSheetReorder(e)}}/><label>是否可拖拽重新排列表单顺序</label>
                        </div>
                    </div>

                    <h3>滚动条</h3>
                    <div>
                        <div>
                            <input type="checkBox" defaultChecked='true' onChange={(e) => {this.horizonScroll(e)}}/><label>显示水平滚动条</label>
                        </div>
                        <button onClick={(e) => {this.horizonScrollTip(e)}}>水平滚动条显示提示</button>
                        <button onClick={(e) => {this.verticalScrollTip(e)}}>竖直滚动条显示提示</button>
                    </div>
                    <h3>绘制</h3>
                    <div>
                        <button onClick={(e) => {this.suspendPaint(e)}}>暂停绘制</button>
                        <button onClick={(e) => {this.resumePaint(e)}}>重新激活绘制</button>
                    </div>
                    <h3>背景</h3>
                    <div>
                        <button onClick={(e) => {this.backColor(e)}}>填充表格背景色</button>
                        <button onClick={(e) => {this.grayAreaBackColor(e)}}>填充灰色区域背景色</button>
                        <p>鼠标拉到最低或最右可见灰色区域填充的背景色</p>
                    </div>
                </div>
                <div className="Layout-main">
                    <div className="title">
                        <a href="https://www.grapecity.com.cn/developer/spreadjs "
                           target="_blank ">产品官网</a>
                        <a href="https://gcdn.grapecity.com.cn/showforum-185-1.html "
                           target="_blank ">论坛求助</a>
                        <a href="https://demo.grapecity.com.cn/SpreadJS/TutorialSample/#/samples "
                           target="_self ">更多示例</a>
                    </div>
                    <div className="sheets">
                        <SpreadSheets workbookInitialized={(e) => {this.workbookInitialized(e)}}>
                            <Worksheet>
                            </Worksheet>
                        </SpreadSheets>
                    </div>
                </div>
            </div>
        )
    }
}

export default Workbook
