import React, {Component} from 'react';
import {SpreadSheets, Worksheet} from '@grapecity/spread-sheets-react';
import '@grapecity/spread-sheets-charts';
import GC from "@grapecity/spread-sheets";
import "@grapecity/spread-sheets-resources-zh";
import "@grapecity/spread-sheets-barcode";
//import FileSaver from "file-saver";
//import ExcelIO from "@grapecity/spread-excelio";

import './Workbook2.css'

GC.Spread.Common.CultureManager.culture("zh-cn");

class WorkbookTwo extends Component {
    constructor(props) {
        super(props);
        this.state = {
            textarea: '',
            inputValue: ''
        };
    }
    // 工作簿初始化
    workbookInitialized(spread) {
        this.spread = spread;
        var sheet = spread.getActiveSheet();
        sheet.options.sheetTabColor = 'green';

        const examdata = [{
            "PATIENT_ID": "932418",
            "PATIENT_LOCAL_ID": "10070683",
            "VISIT_ID": 1,
            "EXAM_GROUP": "彩多全天组",
            "EXAM_NO": "688972",
            "EXAM_CLASS": "彩多",
            "EXAM_SUB_CLASS": "心脏彩超",
            "REQ_PHYSICIAN": "谢景军",
            "EXAM_DATE_TIME": "2010-07-11",
            "STUDY_UID": "1.2.80.112",
            "REQ_DATE_TIME": "2010-07-11",
            "RESULT_STATUS": "确认报告"
        }, {
            "PATIENT_ID": "932418",
            "PATIENT_LOCAL_ID": "100706112",
            "VISIT_ID": 1,
            "EXAM_GROUP": "放射检查组",
            "EXAM_NO": "688525",
            "EXAM_CLASS": "放射",
            "EXAM_SUB_CLASS": "X光摄影",
            "REQ_PHYSICIAN": "谢景军",
            "EXAM_DATE_TIME": "2010-07-12",
            "STUDY_UID": "1.2.80.126",
            "REQ_DATE_TIME": "2010-07-11",
            "RESULT_STATUS": "初步报告"
        }, {
            "PATIENT_ID": "932418",
            "PATIENT_LOCAL_ID": "100706037",
            "VISIT_ID": 1,
            "EXAM_GROUP": "彩多全天组",
            "EXAM_NO": "684881",
            "EXAM_CLASS": "彩多",
            "EXAM_SUB_CLASS": "腹部彩超",
            "REQ_PHYSICIAN": "张建",
            "EXAM_DATE_TIME": "2010-07-15",
            "STUDY_UID": "1.2.840",
            "REQ_DATE_TIME": "2010-07-13",
            "RESULT_STATUS": "确认报告"
        }];
        var sheet = new GC.Spread.Sheets.Worksheet('dataSource');
        sheet.setDataSource(examdata);
        spread.addSheet(1, sheet);

        function MyFunction() {
            GC.Spread.CalcEngine.Functions.Function.apply(this, ["MyFunction", 0, 0]);
            this.typeName = "MyFunction";
        }
        MyFunction.prototype = new GC.Spread.CalcEngine.Functions.Function();
        MyFunction.prototype.evaluate = function(args) {
            var now = new Date();
            return now.getFullYear() + "/" + (now.getMonth() + 1) + "/" + now.getDate();
        };

        var sheet1 = new GC.Spread.Sheets.Worksheet('Function');
        spread.addSheet(2,sheet1);
        sheet1 = spread.getSheet(2);
        sheet1.addCustomFunction(new MyFunction());
        sheet1.setFormula(0, 0, "MyFunction()");
        sheet1.setColumnWidth(0, 150);
        sheet1.setRowHeight(0, 60);


        var oldFun = GC.Spread.Sheets.getTypeFromString;
        // Private types can not be accessed from window, so override getTypeFromString method.
        GC.Spread.Sheets.getTypeFromString = function(typeString) {
            switch (typeString) {
                case "MyFunction":
                    return MyFunction;
                default:
                    return oldFun.apply(this, arguments);
            }
        };

        /*------------------------------事件--------------------------------------*/
        var activeSheetChanging = GC.Spread.Sheets.Events.ActiveSheetChanging;
        var activeSheetChanged = GC.Spread.Sheets.Events.ActiveSheetChanged;
        var SelectionChanging = GC.Spread.Sheets.Events.SelectionChanging;
        var CellClick = GC.Spread.Sheets.Events.CellClick;
        var SelectionChanged = GC.Spread.Sheets.Events.SelectionChanged;
        var EditStarting = GC.Spread.Sheets.Events.EditStarting;
        var EditEnded = GC.Spread.Sheets.Events.EditEnded;
        var SheetMoved = GC.Spread.Sheets.Events.LeftColumnChanged;
        var self = this;
        this.spread.bind(activeSheetChanged, function () {
            self.setState({
                textarea: '活动表单改变'
            })
        });
        this.spread.bind(SelectionChanging, function () {
            self.setState({
                textarea: '选中内容正在改变'
            })
        });
        this.spread.bind(CellClick, function () {
            self.setState({
                textarea: '单元格被点击'
            })
        });
        this.spread.bind(SelectionChanged, function () {
            self.setState({
                textarea: '选中内容改变'
            })
        });
        this.spread.bind(EditStarting, function () {
            self.setState({
                textarea: '开始编辑'
            })
        });
        this.spread.bind(EditEnded, function () {
            self.setState({
                textarea: '编辑结束'
            })
        });
        this.spread.bind(SheetMoved, function () {
            self.setState({
                textarea: '表单停止滚动事件'
            })
        });

        /*----------------------命中测试----------------------------*/
        this.spread.getHost().addEventListener('click', function (e) {
            var y = e.pageY - this.offsetTop;
            var x = e.pageX - this.offsetLeft;
            console.log(x,y);
            var result = self.spread.hitTest(x, y);
            console.log(result);
            var hitInfo = HitInfo(result);

            self.setState({
                inputValue: hitInfo
            })
        })

        function HitInfo(result) {
            if (result){
                var str = '';
                if (result.worksheetHitInfo) {
                    if (result.worksheetHitInfo.hitTestType === 0) {
                        str = 'corner';
                    } else if (result.worksheetHitInfo.hitTestType === 1) {
                        str = 'colHeader';
                    } else if (result.worksheetHitInfo.hitTestType === 2) {
                        str = 'rowHeader';
                    } else {
                        var row = result.worksheetHitInfo.row;
                        var col = result.worksheetHitInfo.col;
                        str = 'viewport; ' + '(row: ' + row + ', col: ' + col + ')';
                    }

                } else if (result.tabStripHitInfo) {
                    if (result.tabStripHitInfo.navButton) {
                        str = result.tabStripHitInfo.navButton;
                    } else if (result.tabStripHitInfo.sheetTab) {
                        str = result.tabStripHitInfo.sheetTab.sheetName;
                    } else if (result.tabStripHitInfo.resize === true) {
                        str = "resize";
                    } else {
                        str = "blank";
                    }
                } else if (result.horizontalScrollBarHitInfo) {
                    str = result.horizontalScrollBarHitInfo.element;
                } else if (result.verticalScrollBarHitInfo) {
                    str = result.verticalScrollBarHitInfo.element;
                } else if (result.footerCornerHitInfo) {
                    str = result.footerCornerHitInfo.element;
                }
            }

            return str;
        }
        /*--------------------------JSON------------------------------------------*/
            /*-----------------------sheet1内容填充开始------------------------**/
        var sheet = spread.getSheet(0);
        var spreadNS = GC.Spread.Sheets;
        sheet.suspendPaint();
        sheet.frozenRowCount(4);
        sheet.frozenColumnCount(4);
        sheet.addSpan(1, 1, 1, 3);
        sheet.setValue(1, 1, '商店');
        sheet.addSpan(1, 4, 1, 7);
        sheet.setValue(1, 4, '物品');
        sheet.addSpan(2, 1, 1, 2);
        sheet.setValue(2, 1, '区域');
        sheet.addSpan(2, 3, 2, 1);
        sheet.setValue(2, 3, '编号');
        sheet.addSpan(2, 4, 1, 2);
        sheet.setValue(2, 4, '水果');
        sheet.addSpan(2, 6, 1, 2);
        sheet.setValue(2, 6, '蔬菜');
        sheet.addSpan(2, 8, 1, 2);
        sheet.setValue(2, 8, '食品');
        sheet.addSpan(2, 10, 2, 1);
        sheet.setValue(2, 10, '合计');
        sheet.setValue(3, 1, '地区');
        sheet.setValue(3, 2, '城市');
        sheet.setValue(3, 4, '葡萄');
        sheet.setValue(3, 5, '苹果');
        sheet.setValue(3, 6, '土豆');
        sheet.setValue(3, 7, '番茄');
        sheet.setValue(3, 8, '面包');
        sheet.setValue(3, 9, '火腿');

        sheet.addSpan(4, 1, 7, 1);
        sheet.addSpan(4, 2, 3, 1);
        sheet.addSpan(7, 2, 3, 1);
        sheet.addSpan(10, 2, 1, 2);
        sheet.setValue(10, 2, '合计:');
        sheet.addSpan(11, 1, 7, 1);
        sheet.addSpan(11, 2, 3, 1);
        sheet.addSpan(14, 2, 3, 1);
        sheet.addSpan(17, 2, 1, 2);
        sheet.setValue(17, 2, '合计:');
        sheet.addSpan(18, 1, 1, 3);
        sheet.setValue(18, 1, '总计:');

        sheet.setValue(4, 1, 'NC');
        sheet.setValue(4, 2, 'Raleigh');
        sheet.setValue(7, 2, 'Charlotte');
        sheet.setValue(4, 3, '001');
        sheet.setValue(5, 3, '002');
        sheet.setValue(6, 3, '003');
        sheet.setValue(7, 3, '004');
        sheet.setValue(8, 3, '005');
        sheet.setValue(9, 3, '006');
        sheet.setValue(11, 1, 'PA');
        sheet.setValue(11, 2, 'Philadelphia');
        sheet.setValue(14, 2, 'Pittsburgh');
        sheet.setValue(11, 3, '007');
        sheet.setValue(12, 3, '008');
        sheet.setValue(13, 3, '009');
        sheet.setValue(14, 3, '010');
        sheet.setValue(15, 3, '011');
        sheet.setValue(16, 3, '012');

        sheet.setFormula(10, 4, '=SUM(E5:E10)');
        sheet.setFormula(10, 5, '=SUM(F5:F10)');
        sheet.setFormula(10, 6, '=SUM(G5:G10)');
        sheet.setFormula(10, 7, '=SUM(H5:H10)');
        sheet.setFormula(10, 8, '=SUM(I5:I10)');
        sheet.setFormula(10, 9, '=SUM(J5:J10)');

        sheet.setFormula(17, 4, '=SUM(E12:E17)');
        sheet.setFormula(17, 5, '=SUM(F12:F17)');
        sheet.setFormula(17, 6, '=SUM(G12:G17)');
        sheet.setFormula(17, 7, '=SUM(H12:H17)');
        sheet.setFormula(17, 8, '=SUM(I12:I17)');
        sheet.setFormula(17, 9, '=SUM(J12:J17)');

        for (var i = 0; i < 14; i++) {
            sheet.setFormula(4 + i, 10, '=SUM(E' + (5 + i).toString() + ':J' + (5 + i).toString() + ')');
        }

        sheet.setFormula(18, 4, '=E11+E18');
        sheet.setFormula(18, 5, '=F11+F18');
        sheet.setFormula(18, 6, '=G11+G18');
        sheet.setFormula(18, 7, '=H11+H18');
        sheet.setFormula(18, 8, '=I11+I18');
        sheet.setFormula(18, 9, '=J11+J18');
        sheet.setFormula(18, 10, '=K11+K18');

        sheet.getRange(1, 1, 3, 10).backColor('#CCCCFF');
        sheet.getRange(4, 1, 15, 3).backColor('#CCFFCC');
        sheet.getRange(1, 1, 3, 10).hAlign(spreadNS.HorizontalAlign.center);

        sheet.getRange(1, 1, 18, 10).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.thin), {all: true});
        sheet.getRange(4, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), {inside: true});
        sheet.getRange(7, 4, 3, 6).setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), {inside: true});
        sheet
            .getRange(11, 4, 3, 6)
            .setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), {inside: true});
        sheet
            .getRange(14, 4, 3, 6)
            .setBorder(new spreadNS.LineBorder('Black', spreadNS.LineStyle.dotted), {inside: true});

        function fillSampleData(sheet, range) {
            for (var i = 0; i < range.rowCount; i++) {
                for (var j = 0; j < range.colCount; j++) {
                    sheet.setValue(range.row + i, range.col + j, Math.ceil(Math.random() * 300));
                }
            }
        }

        fillSampleData(sheet, new spreadNS.Range(4, 4, 6, 6));
        fillSampleData(sheet, new spreadNS.Range(11, 4, 6, 6));

        sheet.resumePaint();
        /*-----------------------sheet1内容填充结束------------------------**/
    }

    workbookInitialized2(spread2) {
        this.spread2 = spread2;
        var sheet = spread2.getActiveSheet();
    }
    /*------------------------------------事件-----------------------------------------------*/
    // 暂停触发事件
    btnEvent1(e) {
        this.spread.suspendEvent();
    };
    // 恢复触发事件
    btnEvent2(e) {
        this.spread.resumeEvent();
    }
    item1() {
        //this.spread1 = spread1;
        var serializationOption = {
            ignoreFormula: false,
            ignoreStyle: false,
            rowHeadersAsFrozenColumns: false,
            columnHeadersAsFrozenRows: false
        };
        var jsonOptions = {
            ignoreFormula: false,
            ignoreStyle: false,
            frozenColumnsAsRowHeaders: false,
            frozenRowsAsColumnHeaders: false,
            doNotRecalculateAfterLoad: false
        };
        console.log("点击进来了");
        //ToJson  spread表格中数据转换成JSON数据
        var jsonStr = JSON.stringify(this.spread.toJSON(serializationOption));

        //FromJson
        this.spread2.fromJSON(JSON.parse(jsonStr), jsonOptions);
        console.log("序列化完成");
    }

    includeBindingSource() {
        var jsonStr = JSON.stringify(this.spread.toJSON({
            includeBindingSource: true
        }));
        //console.log('jsonStr' + jsonStr)
        this.spread2.fromJSON(JSON.parse(jsonStr));
    }

    customize(){
        var jsonStr = JSON.stringify(this.spread.toJSON());
        // FromJson
        this.spread2.fromJSON(JSON.parse(jsonStr));
    }

    render() {
        return (
            <div className={'Layout-container'}>
                <div className="Layout-aside">
                    <h3>事件</h3>
                    <div>
                        <div>
                            <button onClick={(e) => {this.btnEvent1(e)}}>暂停触发事件</button>
                            <button onClick={(e) => {this.btnEvent2(e)}}>恢复触发事件</button>
                        </div>
                        <div>
                            <p>操作右侧表单触发的事件</p>
                            <input type="textarea" defaultValue={this.state.textarea}/>
                        </div>
                    </div>
                    <h3>命中测试</h3>
                    <div>
                        <p>当前命中的区域</p>
                        <input type="text" defaultValue={this.state.inputValue}/>
                    </div>
                    <h3>JSON</h3>
                    <div>
                        <p>在上面的的表格中加入一些数据及样式，点击按钮可生成JSON数据，并在下面的表格中读入该JSON数据。</p>
                        <button onClick={(e) => {this.item1()}}>JSON序列化</button>
                    </div>
                    <h3>数据源序列化</h3>
                    <div>
                        <p>点击下方按钮，可对右侧第二个表格中的数据源进行序列化。</p>
                        <button onClick={(e) => {this.includeBindingSource()}}>数据源序列化</button>
                    </div>
                    <h3>自定义特性序列化</h3>
                    <p>SpreadJS 支持以下自定义特性的序列化与反序列化： 自定义单元格类型， 自定义函数， 自定义格式， 自定义函数迷你图， 自定义标签， 以及自定义行筛选</p>
                    <button onClick={(e) => {this.customize()}}>自定义特性序列化</button>
                </div>
                <div className="Layout-main">
                    <div className="title">
                        <a href="https://www.grapecity.com.cn/developer/spreadjs "
                           target="_blank ">产品官网</a>
                        <a href="https://gcdn.grapecity.com.cn/showforum-185-1.html "
                           target="_blank ">论坛求助</a>
                        <a href="https://demo.grapecity.com.cn/SpreadJS/TutorialSample/#/samples "
                           target="_self ">更多示例</a>
                    </div>
                    <div className="sheets">
                        <SpreadSheets workbookInitialized={(e) => {this.workbookInitialized(e)}}>
                            <Worksheet>
                            </Worksheet>
                        </SpreadSheets>
                    </div>
                    <h4>JSON序列化</h4>
                    <div className="sheets">
                        <SpreadSheets workbookInitialized={(e) => {this.workbookInitialized2(e)}}>
                            <Worksheet>
                            </Worksheet>
                        </SpreadSheets>
                    </div>
                </div>
            </div>
        )
    }
}

export default WorkbookTwo
